/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumHorizontalPrismBase;
import cdac.medinfo.sdk.dcm30_04.enums.EnumVerticalPrismBase;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
/**
* This item class contains methods to validate, set and get the attributes of Prism Sequence .
 */


public class PrismSequenceItem extends Item  
{
	
	/**
	 * serialVersionUID
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item with default TransferSyntax 
	 */
	PrismSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item with specified TS
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax 
	 */
	PrismSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	PrismSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Validates all the attributes in PrismSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule() throws InvalidItemException
	{
		try
		{
			super.validateForModule();
			if(!contains(0x0046,0x0030))
				throw new MandatoryMissingException("0046,0030");
			if(!contains(0x0046,0x0032))
				throw new MandatoryMissingException("0046,0032");
			if(!contains(0x0046,0x0034))
				throw new MandatoryMissingException("0046,0034");
			if(!contains(0x0046,0x0036))
				throw new MandatoryMissingException("0046,0036");
		}
		catch(MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		return true;
	}
	
	/**
	 * Sets the Horizontal Prism Power.
	 * The power of a prism to bend light in the horizontal direction, in prism diopters.
	 * @param dblHorizontalPrismPower Double value of Horizontal Prism Power
	 */
	public void setHorizontalPrismPower(double dblHorizontalPrismPower)
	{
		/*Accept the Horizontal Prism Power in double format of type FD.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0046,0x0030, dblHorizontalPrismPower,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0046,0x0030,DicomConstants.DCM_DT_FD, dblHorizontalPrismPower);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Horizontal Prism Power.
	 * The power of a prism to bend light in the horizontal direction, in prism diopters.
	 * @return double - double value of Horizontal Prism Power
	 */
	public double getHorizontalPrismPower()
	{
		Object objValue = getValue(0x0046,0x0030);
		if(objValue != null)
			return Double.parseDouble(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
	
	/**
	 * Sets the direction of Horizontal Prism Base.
	 * Direction of the base of the measured prism.
	 * Defined Terms:
	 * 1) IN.
	 * 2) OUT.
	 * @param enumHorizontalPrismBase enum value of Horizontal Prism Base.
	 */
	public void setHorizontalPrismBase(EnumHorizontalPrismBase enumHorizontalPrismBase)
	{
		/* Accept the Horizontal Prism Base in String format of type CS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0046,0x0032, enumHorizontalPrismBase.getValue(),getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0046,0x0032,DicomConstants.DCM_DT_CS, enumHorizontalPrismBase.getValue());

		addDataElement(objIDataElement);


	}

	/**
	 * Return direction of Horizontal Prism Base. 
	 * Direction of the base of the measured prism.
	 * @return String - value of Horizontal Prism Base.
	 */
	public String getHorizontalPrismBase()
	{
		Object objValue = getValue(0x0046,0x0032);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets the Vertical Prism Power.
	 * The power of a prism to bend light in the vertical direction, in prism diopters.
	 * @param dblVerticalPrismPower Double value of Vertical Prism Power
	 */
	public void setVerticalPrismPower(double dblVerticalPrismPower)
	{
		/*Accept the Vertical Prism Power in double format of type FD.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0046,0x0034, dblVerticalPrismPower,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0046,0x0034,DicomConstants.DCM_DT_FD, dblVerticalPrismPower);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Vertical Prism Power.
	 * The power of a prism to bend light in the vertical direction, in prism diopters.
	 * @return double - double value of Vertical Prism Power
	 */
	public double getVerticalPrismPower()
	{
		Object objValue = getValue(0x0046,0x0034);
		if(objValue != null)
			return Double.parseDouble(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
	
	/**
	 * Sets the direction of Vertical Prism Base.
	 * Direction of the base of the measured prism.
	 * Defined Terms:
	 * 1) UP.
	 * 2) DOWN.
	 * @param enumVerticalPrismBase enum value of Vertical Prism Base.
	 */
	public void setVerticalPrismBase(EnumVerticalPrismBase enumVerticalPrismBase)
	{
		/* Accept the Vertical Prism Base in String format of type CS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0046,0x0036, enumVerticalPrismBase.getValue(),getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0046,0x0036,DicomConstants.DCM_DT_CS, enumVerticalPrismBase.getValue());

		addDataElement(objIDataElement);


	}

	/**
	 * Return direction of Vertical Prism Base.
	 * Direction of the base of the measured prism. 
	 * @return String - value of Vertical Prism Base.
	 */
	public String getVerticalPrismBase()
	{
		Object objValue = getValue(0x0046,0x0036);
		if(objValue != null)
			return objValue.toString();
		return null;
	}


}
